#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define DEBUG 0


#ifdef __cplusplus /* If this is a C++ compiler, use C linkage */
extern "C" {
#endif

   int asgn_(int,double);
   double sqme(double, double, double);
   double sqme_deg(double, double, double);

#ifdef __cplusplus
}
#endif
  
   
/*
 parameters: all are clear:
    _cutoff_scale means the scale cutoff - if < 0, no formfactor used
 */

void sqme_aaww_c__(double *_amp2, double *_s, double *_t, double *_alpha,
     double* _mw, double *_mz, double *_dkappa, double *_lambda,
     double *_a0w, double *_a0c, double *_cutoff) {

   // apply cutoff  for dkappa and lambda
   double fact = (*_cutoff > 0 ) ? 1/pow(1+*_s/ *_cutoff / *_cutoff, 2) : 1;
   
   double dkappa = *_dkappa*fact;
   double lambda = *_lambda*fact;
   double a0w = *_a0w;
   double a0c = *_a0c;

// mw in comphep can be set through sw and mz only. see service.c for 
// details should not be needed to change if mass of mw is not changed
   double sw = acos(*_mw/ *_mz);
   asgn_(1, *_alpha);
//   asgn_(2, sw);
//   asgn_(3, *_mz); 
   asgn_(4, dkappa);
   asgn_(5, lambda);
   asgn_(6, a0w);
   asgn_(7, a0c);

   double amp2 = sqme(*_s, *_t, *_mw);
   *_amp2 = amp2;
}   
